<template>
  <div class="admin container">
    <div class="box">
      <h1 class="title">Admin panel</h1>
      <b-tabs>
        <b-tab-item label="Models">
          <b-table :data="modelList" :loading="isLoading" striped hoverable>
            <template slot-scope="props">
              <b-table-column field="name" label="Model name" searchable sortable>
                {{ props.row.name }}
              </b-table-column>

              <b-table-column field="verified" label="Verified status" sortable>
                <b-icon v-if="props.row.isVerified" icon="check"/>
                <b-icon v-else icon="close"/>
              </b-table-column>

              <b-table-column field="vote" label="Votes" sortable>
                {{ props.row.votes }}
              </b-table-column>

              <b-table-column field="date" label="Last modification" centered sortable>
                {{ new Date(props.row.lastModified).toLocaleDateString() }}
              </b-table-column>

              <b-table-column field="date" label="Added" centered sortable>
                {{ new Date(props.row.added).toLocaleDateString() }}
              </b-table-column>

              <b-table-column label="" centered>
                <b-button class="actionButton" icon-left="eye" type="is-info" tag="router-link" :to="{ name: 'Model', query: { id: props.row.id } }" outlined/>
                <b-button class="actionButton" icon-left="check" type="is-success" @click="setVerifiedPrompt(props.row.id, props.row.name)" outlined/>
                <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(props.row.id, props.row.name, 'model')" outlined/>
              </b-table-column>
            </template>
          </b-table>
        </b-tab-item>

        <b-tab-item label="Tags">
          <div class="buttons">
            <b-button type="is-info" @click="addNewCategoryDialog">Add Category</b-button>
          </div>

          <b-table :data="tagList" :loading="isLoading" striped hoverable detailed>
            <template slot-scope="props">
              <b-table-column field="name" label="Category" searchable sortable>
                {{ props.row.name }}
              </b-table-column>

              <b-table-column label="" centered>
                  <b-button class="actionButton" icon-left="plus" type="is-info" @click="addNewTagDialog(props.row.id)">Add Tag</b-button>
                  <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(props.row.id, props.row.name, 'category')" outlined>Remove category</b-button>
              </b-table-column>
            </template>

            <template slot="detail" slot-scope="props">
              <tr v-for="tag in props.row.tags" :key="tag.name">
                <td>
                  &nbsp;&nbsp;&nbsp;&nbsp;{{tag.name}}
                </td>
                <td>
                  <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(tag.id, tag.name, 'tag')" outlined/>
                </td>
              </tr>
            </template>

          </b-table>
        </b-tab-item>

        <b-tab-item label="Users">
          <b-table :data="userList" :loading="isLoading" striped hoverable>
            <template slot-scope="props">
              <b-table-column field="username" label="Username" searchable sortable>
                {{ props.row.username }}
              </b-table-column>

              <b-table-column field="email" label="Email" searchable sortable>
                {{ props.row.email }}
              </b-table-column>

              <b-table-column field="role" label="Role" sortable>
                {{ props.row.role }}
              </b-table-column>

              <b-table-column label="" centered>
                <b-button class="actionButton" icon-left="cctv" type="is-success" @click="setAdminPrompt(props.row.id, props.row.username)" outlined/>
                <b-button class="actionButton" icon-left="pencil" type="is-warning" tag="router-link" :to="{ name: 'UserEdit', params: { user: props.row } }" outlined/>
                <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(props.row.id, props.row.username, 'user')" outlined/>
              </b-table-column>
            </template>
          </b-table>
        </b-tab-item>

        <b-tab-item label="Comments">
          <b-table :data="commentList" :loading="isLoading" striped hoverable>
            <template slot-scope="props">
              <b-table-column field="content" label="Content">
                {{ props.row.content }}
              </b-table-column>

              <b-table-column field="username" label="Username" searchable sortable>
                {{ props.row.author.username }}
              </b-table-column>

              <b-table-column field="added" label="Added" sortable>
                {{ props.row.added }}
              </b-table-column>

              <b-table-column label="" centered>
                <b-button class="actionButton" icon-left="delete" type="is-danger" @click="removePrompt(props.row.id, props.row.content, 'comment')" outlined/>
              </b-table-column>
            </template>
          </b-table>
        </b-tab-item>
      </b-tabs>
    </div>
  </div>
</template>

<script>
import { api } from '@/api.js'

export default {
  name: 'Admin',
  data () {
    return {
      isLoading: true,
      userList: [],
      modelList: [],
      tagList: [],
      commentList: []
    }
  },
  async mounted () {
    this.modelList = await api.getModelList()
    this.userList = await api.getUserList()
    this.tagList = await api.getTags()
    this.commentList = await api.getCommentList()
    this.isLoading = false
  },
  methods: {
    removePrompt (id, name, mode) {
      this.$buefy.dialog.confirm({
        message: 'Delete ' + name + ' ?',
        cancelText: 'Abort',
        confirmText: 'Delete',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: async () => {
          switch (mode) {
            case 'user' : await api.removeUser(id); break
            case 'model' : await api.removeModel(id); break
            case 'tag' : await api.removeTag(id); break
            case 'category' : await api.removeCategory(id); break
            case 'comment' : await api.removeComment(id); break
          }
          this.$buefy.toast.open(name + ' deleted')
          this.modelList = await api.getModelList()
          this.userList = await api.getUserList()
          this.tagList = await api.getTags()
          this.commentList = await api.getCommentList()
        }
      })
    },
    addNewTagDialog (categoryId) {
      this.$buefy.dialog.prompt({
        message: 'Tag',
        inputAttrs: {
          maxlength: 20
        },
        confirmText: 'Add',
        onConfirm: async (value) => {
          await api.addNewTag(value, categoryId)
          this.tagList = await api.getTags()
        }
      })
    },
    addNewCategoryDialog () {
      this.$buefy.dialog.prompt({
        message: 'Category',
        inputAttrs: {
          maxlength: 20
        },
        confirmText: 'Add',
        onConfirm: async (value) => {
          await api.addNewCategory(value)
          this.tagList = await api.getTags()
        }
      })
    },
    setVerifiedPrompt (id, name) {
      this.$buefy.dialog.confirm({
        message: 'Set verified status for ' + name + ' ?',
        cancelText: 'Abort',
        confirmText: 'Set',
        type: 'is-success',
        hasIcon: true,
        onConfirm: async () => {
          await api.setVerified(id)
          this.$buefy.toast.open(name + ' verified status has been changed')
          this.modelList = await api.getModelList()
        }
      })
    },
    setAdminPrompt (id, name) {
      this.$buefy.dialog.confirm({
        message: 'Set admin role for ' + name + ' ?',
        cancelText: 'Abort',
        confirmText: 'Set',
        type: 'is-success',
        hasIcon: true,
        onConfirm: async () => {
          await api.setAdmin(id)
          this.$buefy.toast.open(name + ' role has been changed')
          this.userList = await api.getUserList()
        }
      })
    }
  }
}
</script>

<style scoped>
.admin{
  margin-top: 20px;
}
.actionButton {
  margin-left:8px;
}
</style>
